<?php

/**
 * class-my-product-factory - extends the default WC_Product_Factory to load the right My_Product_Calculate instance
 * 
 */


function my_woocommerce_init_set_product_factory() {
	load_my_product_factory_class();

	WC()->product_factory = new My_Product_Factory();
}
add_action('woocommerce_init', 'my_woocommerce_init_set_product_factory', 10, 0);


function load_my_product_factory_class() {
	
	if (class_exists('My_Product_Factory') == false) {
		
		
		class My_Product_Factory extends WC_Product_Factory {
		
			public function get_product( $the_product = false, $args = array() ) {
				$post = get_post($the_product);

				if ($post) {
					$is_my_product = false;
					
					// post_type == 'product_calc_var' ? these post_types are generated for the shopping cart..
					if ($post && $post->post_type == 'product_calc_var') {
						$is_my_product = true;
					}
					
					// 
					if ($is_my_product == false) {
						$product_type = wp_get_object_terms( $post->ID, 'product_type' );
						
						// term product_type set to 'calculate' ?
						if (count($product_type) && $product_type[0]->name == 'calculate') {
							$is_my_product = true;
						}
					}
					
					
					if ($is_my_product) {
						$p = new My_Product_Calculate($post);
						
						return $p;
					}
				}
				
				// fallback to default behavior
				return parent::get_product($the_product, $args);
			}
		
		}
	}
}


