<?php


/**
 * Admin, add tab on product page
 */
add_filter( 'product_type_selector', function($types) {
	$types['calculate'] = __('Product calculate', 'products-on-page');

	return $types;
});


add_filter ( 'woocommerce_product_data_tabs', function ($tabs) {
	$tabs ['calculate'] = array (
			'label' => __ ( 'Calculate product', 'products-on-page' ),
			'target' => 'tab_calculate_product',
			'class' => array (
					'show_if_calculate',
					'hide_if_simple',
					'hide_if_grouped',
					'hide_if_external',
					'hide_if_variable',
					'hide_if_variable' 
			) 
	);
	
	return $tabs;
});


/**
 * tab content
 */
add_action ( 'woocommerce_product_data_panels', function () {
	global $post;
	
	$calculate_type_width = '';
	$calculate_type_height = '';
	
	if ($post) {
		$calculate_type_price_html = esc_html ( get_post_meta ( $post->ID, 'calculate_type_price_html', true ) );
		$calculate_type_width = esc_html ( get_post_meta ( $post->ID, 'calculate_type_width', true ) );
		$calculate_type_height = esc_html ( get_post_meta ( $post->ID, 'calculate_type_height', true ) );
	}
	
	// TODO: use wc_get_template() for templates
	print <<<HTML
	<div id="tab_calculate_product" class="panel woocommerce_options_panel">

		<div class="options_group">
			<p class="form-field">
				<label for="">Default price tag</label>
				<input type="text" name="calculate_type_price_html" value="{$calculate_type_price_html}" />
			</p>
			<p class="form-field">
				<label for="">Multiplier width</label>
				<input type="text" name="calculate_type_width" value="{$calculate_type_width}" />
			</p>
			<p class="form-field">
				<label for="">Multiplier height</label>
				<input type="text" name="calculate_type_height" value="{$calculate_type_height}" />
			</p>
		</div>
	</div>
HTML;
});


/**
 * save settings for product
 */
add_action('save_post', function ($post_id, $post) {
	if ($post->post_type != 'product')
		return;
	
	if (isset ( $_REQUEST ['calculate_type_price_html'] ))
		update_post_meta ( $post_id, 'calculate_type_price_html', $_REQUEST ['calculate_type_price_html'] );
	
	if (isset ( $_REQUEST ['calculate_type_width'] ))
		update_post_meta ( $post_id, 'calculate_type_width', $_REQUEST ['calculate_type_width'] );
	
	if (isset ( $_REQUEST ['calculate_type_height'] ))
		update_post_meta ( $post_id, 'calculate_type_height', $_REQUEST ['calculate_type_height'] );
}, 10, 2);


